%global sname istio
%global debug_package %{nil}

Summary:        CLI for the istio servic mesh in Kubernetes
Name:           istioctl
Version:        1.17.2
Release:        3%{?dist}
License:        Apache-2.0
URL:            https://github.com/istio/istio
Source0:        %{url}/archive/refs/tags/%{version}.tar.gz #/%{sname}-%{version}.tar.gz
# Generated by executing 'go mod vendor' in the decompression directory of Source0
Source1:        vendor.tar.gz

BuildRequires:  go-rpm-macros /usr/bin/pathfix.py

%description
The istioctl tool is a configuration command line utility for service operators
to debug and diagnose their Istio mesh. The Istio project also includes two
helpful scripts for istioctl that enable auto-completion for Bash and ZSH.
Both of these scripts provide support for the currently available istioctl
commands.

%package -n %{name}-bash-completion
Summary:        Bash Completion for %{name}
Requires:       %{name} = %{version}
Requires:       bash-completion
Supplements:    (%{name} and bash-completion)

BuildArch:      noarch

%description -n %{name}-bash-completion
Bash command line completion support for %{name}.

%package -n %{name}-zsh-completion
Summary:        Zsh Completion for %{name}
Requires:       %{name} = %{version}
Supplements:    (%{name} and zsh)

BuildArch:      noarch

%description -n %{name}-zsh-completion
zsh command line completion support for %{name}.

%prep
%autosetup -n %{sname}-%{version} -a 1

%build
go build \
   -mod=vendor \
   -buildmode=pie \
   -ldflags="-X istio.io/pkg/version.buildVersion=%{version} -X istio.io/pkg/version.buildArch=${GOARCH} -X istio.io/pkg/version.buildOS=linux" \
   -o bin/%{name} ./istioctl/cmd/istioctl

%install
install -D -m 0755 bin/%{name} "%{buildroot}/%{_bindir}/%{name}"

mkdir -p %{buildroot}%{_docdir}/%{name}
cp -vr samples %{buildroot}%{_docdir}/%{name}
rm -f %{buildroot}%{_docdir}/%{name}/samples/bookinfo/src/reviews/.gitignore
rm -f %{buildroot}%{_docdir}/%{name}/samples/bookinfo/src/reviews/reviews-wlpcfg/shared/.gitkeep
rm -f %{buildroot}%{_docdir}/%{name}/samples/wasm_modules/header_injector/.gitignore
pathfix.py -pni "%{__python3} %{py3_shbang_opts}" %{buildroot}%{_docdir}/%{name}/samples/bookinfo/src/productpage/productpage.py

mkdir -p %{buildroot}%{_datarootdir}/bash-completion/completions
%{buildroot}/%{_bindir}/%{name} completion bash > %{buildroot}%{_datarootdir}/bash-completion/completions/%{name}

mkdir -p %{buildroot}%{_datarootdir}/zsh_completion.d
%{buildroot}/%{_bindir}/%{name} completion zsh > %{buildroot}%{_datarootdir}/zsh_completion.d/_%{name}

%files
%license LICENSE
%doc README.md
%{_bindir}/%{name}
%{_docdir}/%{name}

%files -n %{name}-bash-completion
%dir %{_datarootdir}/bash-completion/completions/
%{_datarootdir}/bash-completion/completions/%{name}

%files -n %{name}-zsh-completion
%defattr(-,root,root)
%dir %{_datarootdir}/zsh_completion.d/
%{_datarootdir}/zsh_completion.d/_%{name}

%changelog
* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.17.2-3
- Rebuilt for OpenCloudOS Stream 23.09

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.17.2-2
- Rebuilt for OpenCloudOS Stream 23.05

* Tue Apr 25 2023 kianli <kianli@tencent.com> - 1.17.2-1
- initial build
